\RequirePackage{xr-hyper}  % for cleveref; https://tex.stackexchange.com/a/244272/121234 and https://www.latex4technics.com/?note=2uab
\documentclass[9pt,t,serif,professionalfont,xcolor={table,dvipsnames},noamsthm]{beamer}
\PassOptionsToPackage{pdfpagemode=FullScreen}{hyperref}
\setbeamersize{text margin left = 0.5cm,
               text margin right = 0.3cm}
\mode<presentation>
{
  \usetheme{boxes}
  \setbeamercovered{invisible}
  \setbeamertemplate{navigation symbols}{} 
}
\hypersetup{colorlinks=true,linkcolor=blue} 
\definecolor{alertcolor}{RGB}{203, 0 , 34}
\setbeamercolor{alerted text}{fg=alertcolor}

\usepackage[perpage,symbol*,para,multiple]{footmisc}
% Getting undefined commands in aux file
\makeatletter
\newcommand\FN@pp@footnote@aux[2]{\relax}
\makeatother

\let\tmfiles=\relax
\usepackage{../presentation,../presentationfonts}
% \usepackage{../../grammar}

% load the pdfanim style, should be done after hyperref
% \usepackage{pdfanim}

% load and initialise animation
% arguments:
%   \PDFAnimLoad[options]{name}{xxx}{number}
%   - options: in this example the animation is looped
%   - name: name of the animation
%     (with this name it can be reused several times in the document)
%   - number: number of animation frames / files (n)
% the animation will be composed of files
% xxx0.pdf, xxx1.pdf ... xxx(n-1).pdf


\title{Computational complexity}

\author{Jim Hef{}feron}
\institute{
  University of Vermont\\[1ex]
  \texttt{hefferon.net}
}
\date{}

% This is only inserted into the PDF information catalog.
\subject{Computational complexity}

\usepackage{catchfilebetweentags} % read text from background.tex
\newcommand{\catchfilefn}{../../complexity/complexity.tex}
% Keep from swallowing end-of-lines
%   https://tex.stackexchange.com/a/40704/121234
\usepackage{etoolbox}
\makeatletter
\patchcmd{\CatchFBT@Fin@l}{\endlinechar\m@ne}{}
  {}{\typeout{Unsuccessful patch!}}
\makeatother

\usepackage{xr}
  \externaldocument{../../book}
  \externaldocument{../../complexity/complexity}
\usepackage{cleveref}

% \complexityproblems: where the graphics for Complextiy problems are
\renewcommand{\complexityproblemsdir}{../../complexity/asy/problems/}
% Directory of this chapter's asy material
\newcommand{\asydir}{../../complexity/asy/}
% \newcommand{\tmexercises}{\asydir tm_exercises/pdfs/}
% Directory of the src/asy material
\newcommand{\generalasydir}{../../asy/}

% \usepackage{multirow,bigstrut}
\begin{document}
\begin{frame}
  \titlepage
\end{frame}



\section{Review of Big-O}
% ------------------------------------------------------
\begin{frame}
  \frametitle{Definitions}
\ExecuteMetaData[\catchfilefn]{def:ComplexityFcn}
\ExecuteMetaData[\catchfilefn]{def:BigO}

Think of `$f$ is $\bigOh(g)$' as meaning that
$f$'s order of growth is less than or equal to $g$'s.

\pause\medskip
\noindent\textcolor{blue}{\large Points:}
\begin{itemize}
    \item Although Turing machines are discrete devices, we find that  
      functions with real number inputs and outputs are suitable. 
      (The term `complexity function' is not standard
      but we will find it convenient.)
    \item
      We use the letter `$\bigOh$' because this is about the order of growth.
    \item
      The `$f=\bigOh(g)$' notation is awkward but 
      standard.
      The notation `$f\in\bigOh(g)$' is better but not as common.
\end{itemize}
\end{frame}


\begin{frame}{$\bigOh$ compares orders of growth}
For both of these $f$ is $\bigOh(g)$, that is,
$f$'s growth rate is less than or equal to $g$'s rate.
\begin{center}
   % \vcenteredhbox{\includegraphics{asy/complexity00.pdf}}
   % \hspace{2em}
   % \vcenteredhbox{\includegraphics{asy/complexity01.pdf}}
   \includegraphics{asy/complexity01.pdf}
   \hspace{2em}
   \includegraphics{asy/complexity00.pdf}
\end{center}


\begin{itemize}
\item
On the left, $f$ is $\bigOh(g)$ despite that $g(x)<f(x)$ for small~$x$'s.
As $x$ goes to infinity, $g$ races ahead of~$f\!$.
So $f$'s order of growth is strictly less than $g$'s.

\item 
On the right, $f$ is $\bigOh(g)$ despite that $g(x)< f(x)$ for all $x>0$.
As $x$ goes to infinity the two functions track together, so 
$f$'s order of growth is less than or equal to $g$'s.
\end{itemize}
\end{frame}



\begin{frame}{Properties of Big-$\bigOh$}
\ExecuteMetaData[\catchfilefn]{lem:BigOAlgProps}

\pause
\ExecuteMetaData[\catchfilefn]{def:BigTheta}
\ExecuteMetaData[\catchfilefn]{lem:BigThetaEquivalence}
Below, the beans enclose the complexity functions.
Slower growing functions are at the bottom.
On the left the shaded area contains all of the functions in $\bigOh(g)$, 
with the set $\bigTheta(g)$ at the top.
On the right the sketch adds $\bigOh(f)$ for some $f$ in $\bigOh(g)$.
\vspace*{-2ex}
\begin{center}
  \includegraphics[scale=0.9]{\asydir bigo/bigo12.pdf}
  \hspace{4em}
  \includegraphics[scale=0.9]{\asydir bigo/bigo13.pdf}
\end{center}
\end{frame}



\begin{frame}{Computing Big-$\bigOh$}

For many familiar functions the next result is a convenient way to compute
orders of growth.

\ExecuteMetaData[\catchfilefn]{lem:LHBigO}

\pause
To compute the limits we often apply this theorem from 
Calculus.

\ExecuteMetaData[\catchfilefn]{th:LHopital}

\begin{example}
Consider $f(x)=3x^2-2x+4$ and $g(x)=(1/2)x^5-6$.
Take derivatives twice and apply the theorem above 
to conclude that $f$ is~$\bigOh(g)$
but $g$ is not~$\bigOh(f)$.
\begin{equation*}
  \lim_{x\to\infty}\frac{f(x)}{g(x)}
  =
  \lim_{x\to\infty}\frac{3x^2-2x+4}{(1/2)x^5-6}
  =
  \lim_{x\to\infty}\frac{6x-2}{(5/2)x^4}
  =
  \lim_{x\to\infty}\frac{6}{10x^3}=0
\end{equation*}
\end{example}
\end{frame}


\begin{frame}{The Order of Growth Hierarchy}
\ExecuteMetaData[\catchfilefn]{lem:PolySlowerThanExp}

\begin{example}
Where $g$~is the polynomial function $g(x)=x^2$,
this shows that $f(x)=\lg(x)$ is $\bigOh(g)$.
\begin{equation*}
  \lim_{x\to\infty}\frac{f(x)}{g(x)}
  =
  \lim_{x\to\infty}\frac{1/(x\cdot \ln(2))}{2x}
  =\lim_{x\to\infty}\frac{1}{x^2\cdot 2\ln(2)}
  =0
\end{equation*}
\end{example}

\begin{example}
This shows that the polynomial $g(x)=x^2$ is $\bigOh(h)$ where
$h$~is the exponential $h(x)=2^x$.
\begin{equation*}
  \lim_{x\to\infty}\frac{g(x)}{h(x)}
  =
  \lim_{x\to\infty}\frac{x^2}{2^x}
  =
  \lim_{x\to\infty}\frac{2x}{2^x\cdot \ln(2)}
  =
  \lim_{x\to\infty}\frac{2}{2^x\cdot \ln(2)^2}
  =0
\end{equation*}
\end{example}
\end{frame}


\begin{frame}
Some orders of growth
appear often in practice.
Here they are in ascending order, so
$\bigOh(f)$ is listed earlier than $\bigOh(g)$ 
if $f$ is~$\bigOh(g)$ but $g$ is not~$\bigOh(f)$.

\begin{center}\small
\ExecuteMetaData[\catchfilefn]{table:HardyHierarchy}
\end{center}
\end{frame}


\begin{frame}{Cobham's thesis}
We often split that hierarchy between the polynomial
and exponential functions.

A modern computer runs at about 10~GHz,
$10\,000$ million ticks per second,
and there are about $\scinot{3.16}{7}$~seconds in a year.
The chart shows how long a job will take if we use an algorithm
that runs in time $\lg n$, or time~$n$, etc., on inputs of various sizes.
Inside the table the times are in years.
\begin{center}\small
\ExecuteMetaData[\catchfilefn]{table:TractibleAndIntractible}
\end{center}
\pause
\ExecuteMetaData[\catchfilefn]{disc:TractibleAndIntractible}

% Consider the final column.
% At first it increases by an order of magnitude per line, which is significant
% but the values are very small.
% Now look at the last two lines.
% It goes from $10^{-12}$~years to $10^{12}$~years.
% The universe is about $14$~billion years old and a billion is $10^{9}$ years.
% so this exponential computation, even with input size only $100$,
% takes longer than the age of the universe.

\pause
\alert{Cobham's thesis} is that 
the \alert{tractable}
problems\Dash those that are at least conceivably solvable in practice\Dash are
the ones for which there is an algorithm whose resource
consumption is $\bigOh(p)$ for some polynomial~$p$.
\end{frame}




% =============================================================
\section{Problems drive development}
\begin{frame}{Problems}

We shall list a number of problems that are typical of the kind that
researchers in this subject work on.
All of the problems here are very well known.

\ExecuteMetaData[\catchfilefn]{problem:HamiltonianProblem}
\begin{example}
The graph on the left has a Hamiltonian circuit.
The one on the right does not.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/complexity03.pdf}}
  \hspace{4em}
  \vcenteredhbox{\includegraphics{asy/complexity02.pdf}}
\end{center}
On the left we can easily trace out a Hamiltonian circuit.
On the right although we can visit each vertex once and only once,
we cannot get back to the start to make a circuit.
For, all edges connect a vertex on the left with one on the right
and there are more vertices on the left than the right.
To make a circuit we'd have to visit two left vertices in a row,
but the cross-side arrangement of edges doesn't allow that.
\end{example}
\end{frame}



\begin{frame}{\probname{Knight's tour}}
\ExecuteMetaData[\catchfilefn]{discussion:KnightsTouri}
\begin{center}
  \vcenteredhbox{\includegraphics[height=0.7in]{../../complexity/pix/knight.jpg}}
  \hspace{4em}
  \vcenteredhbox{\includegraphics[height=1.2in]{../../complexity/pix/knightstour.png}}
\end{center}
\ExecuteMetaData[\catchfilefn]{discussion:KnightsTourii}
\end{frame}


\begin{frame}{\probname{Traveling Salesman}}

If the graph's edges have weights then we can look for the
Hamiltonian circuit of least total weight.

\ExecuteMetaData[\catchfilefn]{problem:TravellingSalesman}
\begin{center} \small 
  % from Open text: https://optimization.mccormick.northwestern.edu/index.php/Traveling_salesman_problems
  % Image by JessicaYu https://optimization.mccormick.northwestern.edu/index.php/User:JessicaYu
  \includegraphics[scale=0.4]{pix/TSP.png}
\end{center}
\pause
As stated this is an optimization problem, but
we can recast it as a decision problem.
Introduce a threshold bound $B\in\N$ and change the problem to
`decide if
there is a circuit of length less than $B$'.
If we have an algorithm to solve that decision problem then 
we can use it to find the length of the shortest circuit
by first deciding if
there is a trip bounded in length by $B=1$, then deciding if there is a 
trip bounded in length by $B=2$, etc.
\end{frame}



\begin{frame}{\probname{Euler Circuit}}
\ExecuteMetaData[\catchfilefn]{prob:EulerCircuit}
\begin{center}
  \vcenteredhbox{\fcolorbox{boldcolor}{white}{\includegraphics[height=1in]{../../complexity/pix/koenigsberg.jpg}}}
  \hspace{3em}
  \vcenteredhbox{\includegraphics[height=0.5in]{../../complexity/pix/eulerbridges.jpg}}
  \hspace{3em}
  \vcenteredhbox{\includegraphics{../../complexity/asy/problems/problems15.pdf}}
\end{center}

The \probname{Euler Circuit} problem and the 
\probname{Hamiltonian Circuit} problem seem much alike.
In the one we try to traverse each edge while in the other we try to 
visit each vertex.
Perhaps it is a surprise then that we know of a fast algorithm to solve
the first problem but we know of no fast algorithm to solve the second.
\end{frame}


\begin{frame}{\probname{Shortest path}}
\ExecuteMetaData[\catchfilefn]{prob:ShortestPath}
\begin{center}
  \includegraphics{asy/complexity04.pdf}
\end{center}
Between $v_0$ and~$v_7$ this is the shortest path.
\begin{equation*}
  v_0\to v_2\to v_5\to v_4\to v_7
\end{equation*}
\end{frame}


\begin{frame}{\probname{Graph Colorability}}
\ExecuteMetaData[\catchfilefn]{prob:GraphColorabilityi}

\begin{example}
A marina rents boats.
Today there are eight reservations, modelled here as eight vertices.
If reservations have 
overlapping times then we connect the vertices.
Can we cover with four boats?
\only<2->{Yes.}
\begin{center}
  \only<1>{\includegraphics{asy/complexity05.pdf}}
  \only<2->{\includegraphics{asy/complexity06.pdf}}
\end{center}
\end{example}

\pause\pause
\ExecuteMetaData[\catchfilefn]{prob:GraphColorabilityii}

\begin{example}
\probname{Sudoku} ask you to construct a $9$-coloring of a graph, 
given a partial $9$-coloring. 
The graph has vertex for each cell,
so there are $81$~vertices. 
As for edges, there is an edge between the distinct vertices 
if and only if
their cells are in the same column, or row, or
the same $3\times 3$~grid.
\end{example}
\end{frame}



\begin{frame}{\probname{Satisfiability}}
\ExecuteMetaData[\catchfilefn]{prob:SAT}
\ExecuteMetaData[\catchfilefn]{prob:ThreeSAT}

\begin{example}
Is $(P\vee Q\vee R)\wedge(\neg P\vee\neg Q\vee R)\wedge(P\vee\neg Q\vee \neg R)\wedge(\neg P\vee Q\vee \neg R)$ satisfiable?
\begin{center}\small
\only<1>{\begin{tabular}{ccc|ccccc}
  $P$ &$Q$ &\multicolumn{1}{c}{$R$} &$P\vee Q\vee R$ &$\neg P\vee\neg Q\vee R$ &$P\vee\neg Q\vee \neg R$ &$\neg P\vee Q\vee \neg R$ &$\varphi$ \\ \hline
  $F$ &$F$ &$F$ &    &    &    &    &   \\
  $F$ &$F$ &$T$ &    &    &    &    &     \\
  $F$ &$T$ &$F$ &    &    &    &    &     \\
  $F$ &$T$ &$T$ &    &    &    &    &     \\[1ex]
  $T$ &$F$ &$F$ &    &    &    &    &     \\
  $T$ &$F$ &$T$ &    &    &    &    &     \\
  $T$ &$T$ &$F$ &    &    &    &    &     \\
  $T$ &$T$ &$T$ &    &    &    &    &    
\end{tabular}}
\pause
\only<2>{\begin{tabular}{ccc|ccccc}
  $P$ &$Q$ &\multicolumn{1}{c}{$R$} &$P\vee Q\vee R$ &$\neg P\vee\neg Q\vee R$ &$P\vee\neg Q\vee \neg R$ &$\neg P\vee Q\vee \neg R$ &$\varphi$ \\ \hline
  $F$ &$F$ &$F$ &$F$ &$T$ &$T$ &$T$ &$F$  \\
  $F$ &$F$ &$T$ &$T$ &$T$ &$T$ &$T$ &$T$  \\
  $F$ &$T$ &$F$ &$T$ &$T$ &$T$ &$T$ &$T$  \\
  $F$ &$T$ &$T$ &$T$ &$T$ &$F$ &$T$ &$F$  \\[1ex]
  $T$ &$F$ &$F$ &$T$ &$T$ &$T$ &$T$ &$T$  \\
  $T$ &$F$ &$T$ &$T$ &$T$ &$T$ &$F$ &$F$  \\
  $T$ &$T$ &$F$ &$T$ &$F$ &$T$ &$T$ &$F$  \\
  $T$ &$T$ &$T$ &$T$ &$T$ &$T$ &$T$ &$T$  
\end{tabular}}
\end{center}
\end{example}
\end{frame}


\begin{frame}{Problems: graphs}
\ExecuteMetaData[\catchfilefn]{prob:reachability}

(This problem is often known as $st$-conn.)

\ExecuteMetaData[\catchfilefn]{prob:minspanningtree}

\ExecuteMetaData[\catchfilefn]{prob:VertexCover}

\ExecuteMetaData[\catchfilefn]{prob:Clique}

%\ExecuteMetaData[\catchfilefn]{prob:Broadcast}
\ExecuteMetaData[\catchfilefn]{prob:MaxCut}
\end{frame}


\begin{frame}{Problems: combinatorics}
\ExecuteMetaData[\catchfilefn]{prob:ThreeDMatching}

\ExecuteMetaData[\catchfilefn]{prob:SubsetSum}

\ExecuteMetaData[\catchfilefn]{prob:Knapsack}

\ExecuteMetaData[\catchfilefn]{prob:Partition}
\end{frame}


\begin{frame}{Problems: linear programming}
\ExecuteMetaData[\catchfilefn]{prob:LinearProgramming}

\ExecuteMetaData[\catchfilefn]{ex:LinearProgramming}
\end{frame}

\begin{frame}{Problems: games}
\ExecuteMetaData[\catchfilefn]{prob:Crossword}

\ExecuteMetaData[\catchfilefn]{prob:FifteenGame}
\begin{center}
  \includegraphics[width=0.2\textwidth]{../../complexity/pix/15game.png}
\end{center}
\end{frame}


\begin{frame}{Problems: divisibility}
\ExecuteMetaData[\catchfilefn]{prob:Divisors}

\ExecuteMetaData[\catchfilefn]{prob:PrimeFactorization}

\ExecuteMetaData[\catchfilefn]{prob:Composite}
\pause
For many years the consensus among experts was that \probname{Primality}
was probably quite hard.
After all, for centuries many very smart people had worked on the question
and none of them had produced a fast test.
But in 2002 M~Agrawal, N~Kayal, and N~Saxena
proved that primality testing can be done in time polynomial 
in the number of digits of the number.
At this point refinments of their technique run in
$\bigOh(n^6)$.
\begin{center}\small
  \begin{tabular}{c}
    \includegraphics[width=0.25\textwidth]{../../complexity/pix/aks.jpg}  \\
    Nitin Saxena (b~1981), Neeraj Kayal (b~1979), Manindra Agrawal (b~1966)
  \end{tabular}
\end{center}
\end{frame}







% ===================================================
\section{Reflections on problems}

\begin{frame}{Problems, algorithms, and programs}
\begin{itemize}
\item
\ExecuteMetaData[\catchfilefn]{discussion:Problem}

\item
\ExecuteMetaData[\catchfilefn]{discussion:Algorithm}

\item
\ExecuteMetaData[\catchfilefn]{discussion:Program}
\end{itemize}
\end{frame}

\begin{frame}{Other models of computation}
\ExecuteMetaData[\catchfilefn]{disc:OtherModelsOfComputationRAM}
\end{frame}


\begin{frame}{Representations}
We shall assume that for our
algorithms all of the inputs and outputs are in some reasonably 
efficient bitstring representation.

Thus, we shall understand ``given two numbers $n_0,n_1\in\N$'' to mean
`given the bitstring representation of two numbers'.
And 
we shall take ``let $\mathcal{G}$ be a graph'' to mean
`given a reasonably efficient representation of a graph~$\mathcal{G}$'.

Having noted it, we will from now on generally ignore it.
\end{frame}


\begin{frame}{Types of problems}
\begin{itemize}
\item A \alert{function problem}
   asks that the algorithm have a single output for each input.
\pause
\item A \alert{search problem} asks for an algorithm that, 
  while there may be many
  solutions in the search space, will stop when it has found any one.
\pause
\item An \alert{optimization problem} asks for an algorithm that
  gives a solution that is  
  best according to some metric.
\pause
\item A \definend{decision problem} 
  asks for an algorithm with a `Yes' or `No' answer.
  (So it is a Boolean function.
  But is important enough to list on its own, instead of subsumed
  as a function problem.)
\pause
\item Often a decision problem is expressed as a
   \alert{language recognition problem},
   where we are given some language and asked for an algorithm to
   decide if its input is a member of that language.
\end{itemize}

The last is the one that we will work with most often.
\end{frame}



\begin{frame}{Problems}
In this chapter, \alert{problem} usually
means a decision problem for a language.
If we get a problem that isn't a language decision problem
then we will often recast it as one.

\begin{example}
\probname{Subset Sum} inputs a set~$S$ of numbers 
and a target number~$T$, and then decides 
whether a subset of~$S$ adds to the target.
We can recast it as the problem of deciding membership in this language.
\begin{equation*}
  \lang=\set{\sequence{S,T}\suchthat \text{A subset of $S$ adds to~$T$}}
\end{equation*}
Restating the problem as this language leaves it essentially unchanged.
Instead of asserting `there is a subset of $S=\set{19,21,52,106}$ that adds
to~$T=40$' we may say `$\sequence{S,T}\in\lang$'. 
\end{example}

\begin{example}
Consider \probname{Vertex-to-Vertex Path}, where the input is 
a graph and two vertices in the graph and the problem is to decide if
there is a path between the two.
We recast it as the  decision problem for this language.
\begin{equation*}
  \lang=\set{\sequence{\mathcal{G},v,\hat{v}}\suchthat
    \text{there is a path in~$\mathcal{G}$ between the vertices $v$ and~$\hat{v}$}}
\end{equation*}
\end{example}

\begin{example}
To recast \probname{Shortest Path}, introduce a bound~$B\in\N$ parameter.
\begin{equation*}
  \lang_B=\set{\sequence{\mathcal{G},v,\hat{v}}\suchthat
               \text{there is a path between the vertices of length bounded by~$B$}}
\end{equation*}
To find the length of the shortest path, 
see if there is a $B=1$ path, then see if there
is a $B=2$ path, etc. 
\end{example}
\end{frame}

\begin{frame}{Classes}
\ExecuteMetaData[\catchfilefn]{def:ComplexityClass}

Another example is that we might consider all 
language decision problems for which there is 
an algorithm that runs in space $\bigOh(n)$. 
Still another is the set of  
languages where the decision problem for the language's complement 
has an algorithm that runs in polynomial time. 
\end{frame}




% ===================================================
\section{Complexity classes}

\begin{frame}{$\P$}
\ExecuteMetaData[\catchfilefn]{def:P}

Here are some languages whose decision problems are in~$\P$:\begin{parenum}
\item the language of correct sums,
$\lang_1=\set{\sequence{a,b,c}\in\N^3\suchthat a+b=c}$,
\item the language of sorted strings,
$\lang_2=\set{\sigma\in\kleenestar{\set{\str{a},\ldots \str{z}}}\suchthat \text{$\sigma$ is in alphabetical order}}$,
\item the language of correct matrix multiplications,
$\lang_3=\set{\sequence{A,B,C}\suchthat\text{the matrices are such that $AB=C$}}$,
\item the language of primes,
$\lang_4=\set{\str{1}^k\suchthat\text{$k$ is prime}}$,
\item the language of nodes with five neighbors,
$\lang_5=\set{\sequence{\mathcal{G},v}\suchthat\text{vertex~$v$ in $\mathcal{G}$ has exactly five neighbors}}$.  
\end{parenum}

\pause
Here, the bean encloses all 
all decision problems $\lang\subseteq\kleenestar{\B}$.
Problems with slower-growing solution algorithms are at the bottom.
Shaded is the class~$\P$.
This class
contains problems for which there is a solution algorithm  
that is $\bigOh(1)$,
problems for which there is an algorithm that is $\bigOh(\lg n)$,
problems with an algorithm that is $\bigOh(n)$, etc.
\begin{center}
  \vcenteredhbox{\includegraphics{../../complexity/asy/pnp/pnp2003.pdf}}
\end{center}
\end{frame}


\begin{frame}{Effect of the model of computation}
Different models of computation work at different speeds.
In particular, our experience working with Turing machines 
leads us to perceive that they are slow;
does the machine we standardize on affect how we 
classify problems?

Close analysis shows that
Turing machines are slower than other natural models
by no more than a factor of $n^2$ or $n^3\!$.
(We take a model to be `natural' if it
  was not invented just to be a counterexample to this.)
Thus if we have a problem for which there is a
$\bigOh(n)$ algorithm on
another model then when translated to a Turing machine
algorithm it may be $\bigOh(n^4)$.
Under this scenario, 
a problem that falls in the class~$\P$ with one natural model,
including Turing machines,
also falls there using other natural models.

\pause
\begin{remark}  
  There is a possible counterexample to the contention about there being 
  an at-most polytime delay between natural models of 
  physically-realizable devices. 
  Under the Quantum Computing model
  there are several problems with polytime solutions,
  including integer factorization,
  for which we do not know of any polytime solution in a natural
  non-quantum model.
  Whether quantum computers will ever be practical physical devices is not
  at this moment perfectly clear but scientists and engineers are making
  great progress.
  (Also, conceivably there are polytime solutions for these problems
  on Turing machines.)
\end{remark}
\end{frame}


\begin{frame}{Naturalness of the class $\P$}
We will talk a lot about~$\P$ so we will take a moment to reflect
on why.

\begin{itemize}
\item Cobham's Thesis asserts that problems for which there is a polytime
solution form a very important class in practice.

\item As just mentioned, if a problem is in $\P$ based on any familiar model
including Turing machines, RAM, and Racket programs, then
it is in~$\P$ for all of them.

\item We'd like that if two things, $f$ and~$g$, are easy to 
compute then a simple combination of the two is also easy.

\ExecuteMetaData[\catchfilefn]{discussion:PClosure}
\end{itemize}
\end{frame}






% ===================================================
\section{Nondeterministic polynomial time}

\begin{frame}{Nondeterminism}
Recall from the chapter on Finite State machines 
that a machine is nondeterminstic if
from a present configuration and input
it may pass to a next configuration where the number of next states
is zero, or one, or more than one.
This contrasts with a deterministic machine where the number of next 
states is always exactly one.

\ExecuteMetaData[\catchfilefn]{def:NondeterministicTM}
\begin{center}
    \includegraphics{../../complexity/asy/ndtm/ndtm001.pdf}
\end{center}
\end{frame}

\begin{frame}
Recall also that we have two mental models of how these devices operate.
In the first, the machine is unboundedly parallel\Dash when it is 
called on to go to multiple states,
it forks a child process for each one.
That is, the machine's computation history is a tree and it
simultaneously computes all branches.

In the second model, the machine guesses which next state to follow,
or is told which next state to follow by a demon, and
then it 
deterministically computes a check of that branch of the computation tree.

\pause
Described in the language of the first model, 
we say that an input string is accepted if one of the 
branches on the tree is an accepting branch,
and it does not accept the
input if no branch ends in an accepting state.
In terms of the second model, this means that the input
is accepted if there is a sequences of guesses that the machine could
make, or a sequence of
branching hints that the demon could produce,
that the machine can verify leads to an accepting state.

These two models are equivalent in that for a given nondeterministic machine
they yield the same collection of accepted strings.
\end{frame}


\begin{frame}
  \frametitle{Language decider}
The description on the prior slide raises two points.
\ExecuteMetaData[\catchfilefn]{def:NondeterministicDecidersAllBranchesFinite}

Because we require that every branch halts, we can determine
in a finite time that the machine rejects the input.
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{lem:DeterministicAndNondeterministicTMsDoTheSame}

\ExecuteMetaData[\catchfilefn]{pf:DeterministicAndNondeterministicTMsDoTheSame}
\end{frame}


\begin{frame}{Speed}
\vspace*{-1ex}
\ExecuteMetaData[\catchfilefn]{discussion:SpeedOfNFSMi}

\pause
\ExecuteMetaData[\catchfilefn]{discussion:SpeedOfNFSMii}

\ExecuteMetaData[\catchfilefn]{discussion:SpeedOfNFSMiii}
\end{frame}


\begin{frame}{$\NP$}
\ExecuteMetaData[\catchfilefn]{def:NP}

\ExecuteMetaData[\catchfilefn]{lem:PSubsetNP}

%\ExecuteMetaData[\catchfilefn]{rem:DunnoPvsNP}
\pause
We will have much more to say about this later but in short, 
we don't know whether the two sets are equal.
On the left below $\NP$ is shown
as a strict superset of~$\P$ while on the right
the two are shown as equal.
(In all of these bean diagrams, problems with faster solution algorithms
are nearer the bottom.)
\begin{center}
  % \vcenteredhbox{\includegraphics{complexity/asy/pnp/pnp01.pdf}}
  % \hspace{0.6em}
  \vcenteredhbox{\includegraphics{../../complexity/asy/pnp/pnp2004.pdf}}
  \hspace{2.5em}\mbox{versus}\hspace{3em}
  \vcenteredhbox{\includegraphics{../../complexity/asy/pnp/pnp2005.pdf}}
\end{center}
\end{frame}

\begin{frame}{Verifiers}
Mathematical presentations often introduce an idea with a definition that
is natural or conceputally clear and then follow it with
a result giving a characterization that is 
more convenient for working on problems.
The next lemma is an example;~to show that a problem is in $\NP$
we almost always apply it, not the definition.
 
% \ExecuteMetaData[\catchfilefn]{intro:Verifier}

\ExecuteMetaData[\catchfilefn]{def:Verifier}

\ExecuteMetaData[\catchfilefn]{lem:VerifierAndGuesserEquiv}
\pause
\begin{minipage}{0.7\textwidth}\RaggedRight
(The proof will follow some examples.)
The definition says `there exists' a witness~$\omega$.
This formalizes the mental model of the machine 
guessing, or of a demon providing the answer.
Consider the satisfiability example above. 
Imagine the demon whispering, ``Psst! Look at the
$\omega = \str{TTF}$ line.'' 
We can then deterministically verify that hint, quickly.
\end{minipage}
\hspace{1.5em}\vcenteredhbox{\includegraphics[height=0.90in]{../../automata/pix/flauros.jpg}}
\end{frame}



\begin{frame}{Example: \probname{Satisfiability} is in $\NP$}
\ExecuteMetaData[\catchfilefn]{ex:SATIsNPi}
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir flowcharts/flowcharts000.pdf}}
\end{center}
\ExecuteMetaData[\catchfilefn]{ex:SATIsNPiii}
\end{frame}


\begin{frame}
  \frametitle{Comments on the verifier definition and lemma}

\begin{itemize}
\item 
\ExecuteMetaData[\catchfilefn]{disc:Vefieri}
\pause
\item 
\ExecuteMetaData[\catchfilefn]{disc:Vefierii}
\end{itemize}
\end{frame}
\begin{frame}
\begin{itemize}
\item 
\ExecuteMetaData[\catchfilefn]{disc:Vefieriii}

\medskip
\ExecuteMetaData[\catchfilefn]{disc:Vefierv}

\medskip
\ExecuteMetaData[\catchfilefn]{disc:Vefieriv}
\end{itemize}
\end{frame}
\begin{frame}
\begin{itemize}

\item 
\ExecuteMetaData[\catchfilefn]{disc:Vefiervi}
\end{itemize}
\end{frame}


\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:HamPathIsNPi}
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir flowcharts/flowcharts001.pdf}}
\end{center}
\ExecuteMetaData[\catchfilefn]{ex:HamPathIsNPii}
\end{frame}


\begin{frame}
\begin{example}
\probname{Vertex-to-Vertex Path}
takes as input a graph and two vertices and the triple is in the language if
there is a path between the vertices.
\begin{equation*}
  \lang=\set{\sequence{\mathcal{G},v,\hat{v}}\suchthat
              \text{there is a path in $\mathcal{G}$ from $v$ to $\hat{v}$}}
\end{equation*}
This problem is in $\NP$.
For the witness~$\omega$, use the path.
We can write a verifier~$\TM[V]$ that accepts a 
triple~$\sigma=\sequence{\mathcal{G},v,\hat{v}}$ along with a 
witness path~$\omega$, 
and tries to verify that the path lies in the graph between
the two vertices.
If there is such a path then there is a pair $\sequence{\sigma,\omega}$ 
that $\TM[V]$ can accept.
If there is no such path then there is no such pair. 
Clearly verification is fast, polytime.
\end{example}

\pause
\begin{example}
\alert{\probname{Linear programming}} optimizes some linear function
$f(x_0,\ldots x_{n-1})=a_0x_0+\cdots+a_{n-1}x_{n-1}$, called the objective function, 
subject to a list~$C$ of constraints of the form
$b_{i,0}x_0+\cdots+b_{i,n-1}x_{n-1}\leq d_i$ and $x_i\geq 0$.
To make this a language decision problem, recast it using a parameter 
lower bound~$B$.
\begin{equation*}
  \lang_B=\set{\sequence{f,C}\suchthat
    \text{some $\sequence{x_0,\ldots x_{n-1}}$ satisfies the constraints~$C$ and~$f(x_0,\ldots x_{n-1})\geq B$}}
\end{equation*}
We can write a verifier~$\TM[V]$ that takes in a
pair~$\sequence{\sigma,\omega}$, where $\sigma$ is a pair $\sequence{f,C}$ and
$\omega$ is a tuple,~$\sequence{x_0,\ldots{}x_{n-1}}$,
and where the verifier checks whether the tuple satisfies the
constraints and also makes the objective function larger than~$B$.
If there is such a sequence then $\TM[V]$ can verify it, in polytime.
If there is no such sequence then $\TM[V]$ can never accept its input.  
\end{example}

\pause
\begin{example}
\alert{\probname{$3$-Coloring}} takes a graph as input
and decides if it can be colored with at most $3$~colors.
For~$\omega$ use a purported $3$-coloring.
The machine $\TM[V]$ can verify that $\omega$ actually is a $3$-coloring  
in time polynomial in the size of the graph.
\end{example}
\end{frame}

\begin{frame}{Proof of the lemma}
Here is the statement of the lemma again.

\ExecuteMetaData[\catchfilefn]{lem:VerifierAndGuesserEquiv}

\proofname \ExecuteMetaData[\catchfilefn]{pf:VerifierAndGuesserEquivi}
\end{frame}
\begin{frame}
\ExecuteMetaData[\catchfilefn]{pf:VerifierAndGuesserEquivii}
\qedsymbol
\end{frame}






% ===================================
\section{Problem reduction}
\begin{frame}{Introduction}
\ExecuteMetaData[\catchfilefn]{disc:PolyTimeReductioni}

\pause
This is terminology that is used generally in Mathematics.
We say that a problem $B$ `reduces to' $A$
when in order to solve $B$, it suffices to solve~$A$.
Here are two examples.
\begin{center}
  \begin{tabular}{*{2}{p{0.45\linewidth}}}
    \multicolumn{1}{c}{\tabulartext{Problem $B$}} 
       &\multicolumn{1}{c}{\tabulartext{Problem $A$}}  \\
    \hline
    \rule{0pt}{12pt}Find the maximum of a list of numbers
       &Sort a list of numbers        \\[0.75ex]
    Find the roots of a polynomial
       &Factor a polynomial into linear terms over the complex numbers
  \end{tabular}
\end{center}
The intuition is that $A$ is at least as hard as $B$.
\end{frame}

\begin{frame}{Reduction between language decision problems}
Recall \probname{Vertex-to-Vertex Path}:~given a graph and two vertices,
decide if there is a path between them.
Recall also \probname{Shortest Path}:~given a weighted graph and two
vertices, find the shortest path between them.

These two are related in that if you can find the shortest path 
then you can find
whether there is a path at all.

\pause
As a run-up toward the definition that makes this relationship precise, 
we first state these as language decision problems.
\begin{align*}
  \lang &=\set{\sequence{\mathcal{G},v_0,v_1}\suchthat
               \text{there is a path from $v_0$ to $v_1$ in $\mathcal{G}$}} \\
  \lang_B &=\set{\sequence{\hat{\mathcal{G}},w_0,w_1}\suchthat
               \text{there is a path from $w_0$ to $w_1$ shorter than length~$B$}}
\end{align*}
(With the second, we are applying the standard bound technique, using 
the parameter~$B\in\N$.
Also, there is a type issue because
\probname{Shortest Path} applies to weighted graphs.
But we can patch up the type issue by taking an unweighted graph to be 
a weighted one where each edge has weight~$1$.)
\end{frame}

\begin{frame}
Suppose that you could solve \probname{Shortest Path}.
Perhaps you have a library routine \str{SolveShortestPath}.
We say that you have a `Shortest Path oracle'.
This sketches an algorithm leveraging that oracle to give an
algorithm that solves \probname{Vertex-to-Vertex Path}.
\begin{center}
  \includegraphics{asy/complexity07.pdf}
\end{center}
\pause
This computes a function which translates decisions about
instances of
\probname{Vertex-to-Vertex Path}
into decisions about instances of \probname{Shortest Path}.

In particular, because the algorithm runs in polytime, 
if \probname{Shortest Path} is in $\P$ then
\probname{Vertex-to-Vertex Path} is also in~$\P$.
\end{frame}



\begin{frame}{Polytime reduction}
\ExecuteMetaData[\catchfilefn]{def:PolyTimeReduction}
% \end{frame}
% \begin{frame}
This is a sketch of polytime reduction among problems.
The bean encloses all problems, which we take to be languages, 
subsets of $\kleenestar{\B}$
(we only show a few problems for graphical clarity).
The easy ones, the ones with fast solution algorithm, are at the bottom.
  Problems are shown connected if there is a polynomial time reduction from one 
  to the other.
  Highlighted are connections within the complexity class~$\P$.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir pnp/pnp2008.pdf}}
\end{center}
\end{frame}



\begin{frame}{$\probname{Satisfiability}\leq_p\probname{Clique}$}
\ExecuteMetaData[\catchfilefn]{ex:SATLeqCliquei}

\ExecuteMetaData[\catchfilefn]{ex:SATLeqCliqueii}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:SATLeqCliqueiii}
\begin{center}
  \includegraphics{\asydir complexity/complexity39.pdf}
\end{center}
\ExecuteMetaData[\catchfilefn]{ex:SATLeqCliqueiv}
% \end{frame}

% \begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:SATLeqCliquev}
\end{frame}

\begin{frame}{$\probname{Graph Colorability}\leq_p\probname{Satisfiability}$}
\ExecuteMetaData[\catchfilefn]{ex:ColorabilityLeqSATi}
This is a $3$-coloring of the graph.
\begin{center}
  \includegraphics{../../complexity/asy/complexity/complexity01.pdf}
\end{center}
\ExecuteMetaData[\catchfilefn]{ex:ColorabilityLeqSATii}

To demonstrate that 
$\probname{Graph Colorability}\leq_p\probname{Satisfiability}$, 
we must show that given an instance of \probname{Graph Colorability},
we can translate it into an instance of \probname{Satisfiability}
(where the translation algorithm takes polytime).
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:ColorabilityLeqSATiii}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{ex:ColorabilityLeqSATiv}
\ExecuteMetaData[\catchfilefn]{ex:ColorabilityLeqSATv}
\end{frame}



\begin{frame}{$\probname{Vertex Cover}\leq_p\probname{Set Cover}$}
\probname{Vertex Cover} inputs a graph 
$\mathcal{G}=\sequence{\mathcal{V},\mathcal{E}}$ and a number $B\in\N^+\!$.
It asks if there are vertices $v_{i_0},v_{i_1},\ldots\,v_{i_{B-1}}$ so that 
each edge contains at least one such vertex.

\begin{example}
Your museum has nine corridors and you must have a guard in a corner of each
corridor.
\begin{center}
  \includegraphics{asy/complexity08.pdf}
\end{center}
You can get away with $B=4$ guards, posted at $v_1$, $v_2$, $v_5$, and~$v_7$.
\end{example}

\pause
\probname{Set Cover} inputs a set~$U$, a number $B\in\N^+\!$,
and a collection $S_0, S_1, \ldots\, S_m$ of subsets of~$U$.
It asks if there is a subcollection whose union is the entire set
$S_{i_0}\cup S_{i_1}\cup \cdots \cup S_{i_{B-1}}=U$. 

\begin{example}
Imagine you are hiring people and have ten skills that you need to cover,
$U=\set{0,1,\ldots\,9}$.
The four applicants list these skills.
\begin{equation*}
  S_0=\set{1,4}\quad
   S_1=\set{2,3,4,5}\quad
   S_2=\set{0,7,9}\quad
   S_3=\set{1,6,8}
\end{equation*}
You can get away with hiring only $B=3$ applicants 
because $S_1\cup S_2\cup S_3=U$.
\end{example}
\end{frame}

\begin{frame}
We will show that
$\probname{Vertex Cover}\leq_p\probname{Set Cover}$ by 
showing how to translate instances of \probname{Vertex Cover} into instances
of \probname{Set Cover}.

First write each as a language decision problem.
\begin{align*}
  \lang_0 &=\set{\sequence{U,\set{S_0,\ldots S_m},B}\suchthat
               \text{some $S_{i_0}, S_{i_1}, \ldots\, S_{i_{B-1}}$ covers $U$}}
  \\
  \lang_1 &=\set{\sequence{\mathcal{G},B}\suchthat
               \text{some set $v_{i_0},v_{i_1},\ldots\,v_{i_{B-1}}$ covers all edges}}      
\end{align*}
We must produce a 
polytime computable function~$f$ that
takes in ~$\sigma=\sequence{\mathcal{G},B}$
and outputs $f(\sigma)=\sequence{U,\set{S_0,\ldots S_m},B}$, such that
$\sigma\in\lang_1$ if and only if $f(\sigma)\in\lang_0$. 

\pause
Given $\sigma=\sequence{\mathcal{G},B}$, 
take $U$ to be the set of~$\mathcal{G}$'s edges.
For each of $\mathcal{G}$'s vertices $v_i\in\mathcal{V}$, let
$
S_{v_i}=\set{e\in\mathcal{E}\suchthat \text{$v_i$ is a vertex in $e$}}
$.
Define $f(\sigma)=\sequence{U,\set{S_0,\ldots S_m},B}$.

Clearly we can compute $f$ in polytime.
Further, for the bound~$B$ there is a collection of sets 
$S_{v_0}\cup S_{v_1}\cup \cdots\, S_{v_{B-1}}$ if and only if
the collection $v_0,v_1,\ldots v_{B-1}$ is a vertex cover of~$\mathcal{G}$.
\begin{example}
For the corridor guards, $\mathcal{G}$, 
the associated sets are $U=\set{a,b,\ldots{} i}$, along with
$S_{v_1}=\set{a,b,d}$, 
and $S_{v_2}=\set{b,c,e}$, \ldots{}
and~$S_{v_7}=\set{f,h,i}$.
\begin{center}
  \vcenteredhbox{\includegraphics{asy/complexity09.pdf}}
\end{center}
The set cover $\set{S_{v_1},S_{v_2},S_{v_5},S_{v_7}}$ gives a vertex cover
$\set{v_1,v_2,v_5,v_7}$.
\end{example}
\end{frame}



\begin{frame}{Properties of polytime reduction}
\ExecuteMetaData[\catchfilefn]{lem:PolytimeReductionTrans}

\proofname \ExecuteMetaData[\catchfilefn]{pf:PolytimeReductionTransi}

% \pause
\ExecuteMetaData[\catchfilefn]{pf:PolytimeReductionTransii}
\qedsymbol
\end{frame}


% ===================================================
\section{$\protect\compclass{NP}$ completeness}

\begin{frame}{The Cook-Levin theorem}
\ExecuteMetaData[\catchfilefn]{th:CookLevin}

\ExecuteMetaData[\catchfilefn]{pf:CookLevini}

\ExecuteMetaData[\catchfilefn]{pf:CookLevinii}
\end{frame}

\begin{frame}{$\NP$ complete, $\NP$ hard}
\ExecuteMetaData[\catchfilefn]{def:NPComplete}

This shows all problems,
  the collection of all $\lang\in\kleenestar{\B}\!$.
  In the bottom is~$\NP$, drawn with $\P$ as
  a proper subset (although we don't know this is true,
  most experts believe that it is).
  In the top are the $\NP$-hard problems.
  The highlighted intersection of the two
  is the set of $\NP$ complete problems.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir pnp/pnp2007.pdf}}
\end{center}

\ExecuteMetaData[\catchfilefn]{lem:NPCompleteIsTransitive}
\end{frame}


\begin{frame}{The key six $\NP$ complete problems}
\ExecuteMetaData[\catchfilefn]{th:GJNPCompleteProblems}
\end{frame}


\begin{frame}{\probname{Travelling Salesman} is $\NP$-complete}
\begin{example}
\ExecuteMetaData[\catchfilefn]{ex:TSIsNPComplete}
\end{example}
\end{frame}


\begin{frame}{\probname{Knapsack} is $\NP$-complete}
\ExecuteMetaData[\catchfilefn]{ex:KnapsackIsNPComplete}
\end{frame}


\begin{frame}{$\EXP$}
\ExecuteMetaData[\catchfilefn]{def:EXP}

\ExecuteMetaData[\catchfilefn]{discussion:EXP}

\pause
\ExecuteMetaData[\catchfilefn]{lem:PSubNPSubEXP}

\ExecuteMetaData[\catchfilefn]{pf:PSubNPSubEXP}
\end{frame}

\begin{frame}{Dunno}
We don't know whether there are any $\compclass{NP}$ problems that
absolutely require exponential time.
Conceivably $\compclass{NP}$ is contained in a smaller determinstic
time complexity class\Dash maybe \probname{Satisfiability}, for instance,
can be solved in less than exponential time.
But we just don't know.

Here the blob encloses all problems.
   Shaded are the three classes $\P$, $\NP$, and $\EXP$.
   They are drawn with strict containment, which most experts guess
   is the true arrangement, but no one knows for sure.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir pnp/pnp2006.pdf}}
\end{center}
\end{frame}



% ========================================
\section{$\protect\P$ versus $\protect\NP$}

\begin{frame}{?$\P=\NP\,$?}
Every deterministic Turing machine is trivially a nondeterministic machine,
and so $\P\subseteq\NP$.
What about the other direction:~can unbounded parallelism bring problems
from super-polynomial to polynomial?

The short answer is that no one knows.
One of these two pictures is correct but
we do not know which one.
\begin{center}
  % \vcenteredhbox{\includegraphics{complexity/asy/pnp/pnp01.pdf}}
  % \hspace{0.6em}
  \vcenteredhbox{\includegraphics{\asydir pnp/pnp2004.pdf}}
  \hspace{5em}
  \vcenteredhbox{\includegraphics{\asydir pnp/pnp2005.pdf}}
\end{center}
\end{frame}


\begin{frame}{The place of $\NP$ complete problems}
This bean holds all language decision problems,
$\lang\in\kleenestar{\B}$.
In the bottom is~$\NP$, drawn with $\P$ as
a strict subset (although we don't, strictly speaking, know that is true).
In the top left are the $\NP$-hard problems.
The highlighted intersection of the two
is the set of $\NP$ complete problems.
These problems are elements of~$\NP$
that are $\leq_p$-above all $\NP$ problems.
They are the hardest of the $\NP$ problems.
If there is a difference between $\P$ and~$\NP$, a gap containing the
problems that are in $\NP-\P$, then they form a subset of 
it, right at its very top.
\begin{center}
  \vcenteredhbox{\includegraphics{\asydir pnp/pnp2007.pdf}}
\end{center}
\end{frame}



\begin{frame}{What's so interesting about $\NP$ complete problems?}
\ExecuteMetaData[\catchfilefn]{discussion:KarpsProblems}

\ExecuteMetaData[\catchfilefn]{discussion:PvsNPi}

If someone could solve just one of these problems in polytime 
then we could solve all of them in polytime. 
\end{frame}

\begin{frame}{In short: what to tell your boss}
What if you have a problem that you cannot solve?

\ExecuteMetaData[\catchfilefn]{discussion:PvsNPInPractice}

A researcher could imagine proving that the reason they cannot
find an efficient algorithm is that no such algorithm exists.
But perhaps more realistic is to show that your problem is 
$\NP$~complete and then argue that while you cannot 
find an efficient algorithm, neither can anyone else\Dash that you
are at the state of the art.
% \medskip
%   \only<1>{\textcolor{blue}{Not ideal:} \begin{center}\includegraphics[height=1.75in]{pix/gjcartoon1.png}\end{center}}%
%   \only<2>{\textcolor{blue}{Ideal, but not happening:} \begin{center}\includegraphics[height=1.75in]{pix/gjcartoon2.png}\end{center}}%
%   \only<3>{\textcolor{blue}{The third way: show that your problem is $\NP$ complete} \begin{center}\includegraphics[height=1.75in]{pix/gjcartoon3.png}\end{center}}

% \medskip
% {\scriptsize (Cartoon from Garey and Johnson's book.)}
\end{frame}




\begin{frame}{Status of the question}
\ExecuteMetaData[\catchfilefn]{discussion:PvsNPii}
\end{frame}


\begin{frame}{Reflection: why the question is central}
In high school you had Euclid.
This proves that the base angles of an isosceles triangle are equal. 
\begin{center}  % https://www.gutenberg.org/files/21076/21076-pdf.pdf
  \includegraphics[height=2.2in]{pix/euclid.png}
\end{center}
A proof is a sequence of statements, each justified by reference to 
some prior statement, to a law of logic, or to some axiom.
\end{frame}

\begin{frame}
In a proof we require the all steps be typographic 
in the sense that we can for instance combine two prior statements using
a law of logic to get a third statement,
but a proof cannot take creative leaps.
It must be mechanically checkable.  

This is illustrated by Russell and Whitehead's 
\textit{Principia Mathematica}, from the early 1900's, 
which tried to derive all of mathematics from first principles,
in a way that is completely mechanically checkable.
Each step describes the lines from which it is
derived, so that for instance 
you can mechanically check that the second line follows from the
first by applying the result $51.231$.

This appears on p~362. 
\begin{center}  
  \includegraphics[height=1.25in]{pix/russellwhitehead.png}
\end{center}
% So it at least may appear that doing mathematics from first principles,
% going back and proving all results completely, may be extremely slow.
\end{frame}




\begin{frame}
\ExecuteMetaData[\catchfilefn]{discussion:Entscheidungsproblemi}

Restated:~start with the axioms.
Do a one step combination of them in all possible ways.
Then do all two-step combinations, etc.
This process generates all possible theorems, eventually. 
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{discussion:Entscheidungsproblemii}

\end{frame}

\begin{frame}
\begin{center}
  \begin{tabular}{c}
  \vcenteredhbox{\includegraphics[height=0.6in]{../../prologue/pix/turing.jpg}} \\
  A~Turing
  \end{tabular}
  \quad
  \begin{tabular}{c}
  \vcenteredhbox{\includegraphics[height=0.6in]{../../background/pix/godel.jpg}} \\
  K~G\"{o}del
  \end{tabular}
  \quad
  \begin{tabular}{c}
  \vcenteredhbox{\includegraphics[height=0.6in]{../../prologue/pix/vonneumann.jpg}} \\
  J~von Neumann
  \end{tabular}
\end{center}
\ExecuteMetaData[\catchfilefn]{discussion:Entscheidungsproblemiii}
%\end{frame}
%
%\begin{frame}
% \pause\vspace{-3.5ex}
This problem is in $\NP$.
If someone gives you a theorem's derivation~$\omega$ then checking it 
is fast.
But, that we know today, 
it appears that generating the theorems is slow.
Certainly, the brute force, 
breadth-first, way is slow.
\end{frame}


\begin{frame} % {Hand waving}
G\"{o}del was extremely cautious.  
We can expand what he said into statements that are
somewhat less careful but perhaps
more memorable.
% \pause
% \begin{center}
% \includegraphics[height=0.75in]{pix/bs.jpg}
% \end{center}
% \end{frame}
\pause
% \begin{frame}{Two examples} 
% https://commons.wikimedia.org/wiki/File:Sudoku_Puzzle_by_L2G-20050714_standardized_layout.svg
\begin{example}
Consider how the difficulty of an $n\times n$ \probname{Sudoku} grid
grows as~$n$ grows.
\begin{center}
  \includegraphics[height=0.7in]{pix/sudoku.png}
\end{center}
This problem is $\NP$ because as a witness~$\omega$ we can use
a filled-out grid, and check it quicky.
But, we today know of no polytime solution.
\end{example}
\begin{example}
Jigsaw puzzles are similar.
\begin{center}
  \includegraphics[height=0.7in]{../../complexity/pix/jigsaw.png}
\end{center}
This is $\NP$ because we can get as witness~$\omega$ a finished
puzzle. 
But like the $\SAT$ problem, researchers today do not know of
any way to solve it that is essentially faster than trying all combinations.
\end{example}
\end{frame}


\begin{frame} % {Waxing poetic}
S~Cook: 

\begin{quote}\small % https://www.claymath.org/sites/default/files/pvsnp.pdf
\noindent \ldots{} a practical algorithm for solving an $\NP$-complete problem
\ldots{}
would transform mathematics by allowing a computer to find a formal
proof of any theorem that has a proof of reasonable length, 
since formal proofs can
easily be recognized in polynomial time. 
\ldots{} 
Although the formal proofs may not be initially intelligible
to humans, the problem of finding intelligible proofs would be reduced to that
of finding a recognition algorithm for intelligible proofs. 
Similar remarks apply
to diverse creative human endeavors, such as designing airplane wings, creating
physical theories, or even composing music. 
The question in each case is to what
extent an efficient algorithm for recognizing a good result can be found.
\end{quote}

S~Aaronson: % https://www.scottaaronson.com/blog/?p=122

\begin{quote}\small
If $\P=\NP$, then the world would be a profoundly different place 
than we usually assume it to be. 
There would be no special value in ``creative leaps,'' no fundamental 
gap between solving a problem and recognizing the solution once it's found. 
Everyone who could appreciate a symphony would be Mozart; everyone 
who could follow a step-by-step argument would be Gauss; everyone who 
could recognize a good investment strategy would be Warren Buffett.
\end{quote}

A Widgerson: % http://www.math.ias.edu/~avi/PUBLICATIONS/MYPAPERS/AW09/AW09.pdf

\begin{quote}\small
The seemingly abstract, philosophical question: 
\textit{Can creativity be automated?} in its concrete, mathematical 
form: \textit{Does $\P = \NP$?},
emerges as a central challenge of science. And the basic notions of
space and time, studied as resources of efficient computation, emerge
as key objects of study to solving this mystery, just like their physical
counterparts hold the key to understanding the laws of nature.
\end{quote}
\end{frame}


\begin{frame}{Guessing whether $\P=\NP$: the dominant view}
\ExecuteMetaData[\catchfilefn]{discussion:PvsNPiii}

\pause
% credit: https://math.stackexchange.com/a/2547613/12012
Related reasoning is that there are thousands of $\NP$ complete problems 
spread across disciplines such as combinatorics, 
number theory, geometry, economics and finance, biology, operations research, 
etc. 
These problems differ wildely and bear no obvious relation to each other, 
besides the fact that they are all $\NP$ complete. 
Because they are $\NP$ complete, they are mutually inter-reducible,
so a polytime solution to one would give a polytime solution to all.
No one has been able to find a polytime algorithm to solve any of them.
This is strong empirical evidence\Dash not proof, to be sure, but still strong
evidence\Dash that $\P\neq\NP$.
\end{frame}

\begin{frame}{Guessing whether $\P=\NP$: the contrarian view}
\ExecuteMetaData[\catchfilefn]{discussion:PvsNPiv}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{discussion:PvsNPv}
\end{frame}

\begin{frame}
\ExecuteMetaData[\catchfilefn]{discussion:PvsNPvi}
\end{frame}
\end{document}




